package com.client;

import com.shared.FieldVerifier;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyDownEvent;
import com.google.gwt.event.dom.client.KeyDownHandler;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;


/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class DaysElapsedCliSer implements EntryPoint, KeyDownHandler  {
  /**
   * The message displayed to the user when the server cannot be reached or
   * returns an error.
   */
  private static final String SERVER_ERROR = "An error occurred while "
      + "attempting to contact the server. Please check your network "
      + "connection and try again.";

  /**
   * Create a remote service proxy to talk to the server-side Greeting service.
   */
  private final GreetingServiceAsync greetingService = GWT.create(GreetingService.class);

  Label MonthPrompt;
  Label DayPrompt;
  Label YearPrompt;
  TextBox TheMonth;
  TextBox TheDay;
  TextBox TheYear;
  Label Output;
  final int frameWidth=100;
 
  /**
   * This is the entry point method.
   */
  public void onModuleLoad() {
	  // Use either a border layout with north/south, or a grid layout with
	  //  one column and two rows. NO.. with GWT we will pick a panel or panels
	  // We'll use a Vertical Panel. The first 3 sections will each hold a
	  //	horizontal panel with 2 sections, one for a prompt and one for 
	  //	the text box to hold the input


	  // Now, set up a Panel to hold the interface
	  VerticalPanel Interface=new VerticalPanel();

	  // Set size of this panel
	  Interface.setSize(String.valueOf(frameWidth),String.valueOf(90));

	  // Add a fancy border to the Interface panel
	  // This is now css work...
	  // Interface.setBorder(BorderFactory.
	  //			createEtchedBorder(Color.orange,Color.blue));

	  // Now, add the individual interfaces for month, day and year. Each will
	  //      be in its own HorizontalPanel
	  HorizontalPanel pMonth=new HorizontalPanel();
	  // Set size of panel
	  pMonth.setSize(String.valueOf(frameWidth),String.valueOf(15));
	  // Need a prompt
	  MonthPrompt=new Label("Enter the month\t");
	  // Place the prompt on the panel
	  pMonth.add(MonthPrompt);
	  // Need a textfield to read the TheMonth
	  TheMonth=new TextBox();
	  TheMonth.setVisibleLength(2);
	  // Add it to the panel
	  pMonth.add(TheMonth);
	  // Add the HorizontalPanel to the Interface
	  Interface.add(pMonth);

	  HorizontalPanel pDay=new HorizontalPanel();
	  pDay.setSize(String.valueOf(frameWidth),String.valueOf(15));
	  DayPrompt=new Label("Enter the day\t");
	  pDay.add(DayPrompt);
	  TheDay=new TextBox();
	  TheDay.setVisibleLength(2);
	  pDay.add(TheDay);
	  Interface.add(pDay);

	  HorizontalPanel pYear=new HorizontalPanel();
	  pYear.setSize(String.valueOf(frameWidth),String.valueOf(15));
	  YearPrompt=new Label("Enter the year\t");
	  pYear.add(YearPrompt);
	  TheYear=new TextBox();
	  TheYear.setVisibleLength(2);
	  pYear.add(TheYear);
	  Interface.add(pYear);

	  // Set up Panel to hold Result label. Label will be left justified
	  HorizontalPanel Result=new HorizontalPanel();
	  Result.setSize(String.valueOf(frameWidth),String.valueOf(10));
	  Output=new Label("            ");
	  Result.add(Output);

	  // Add styles for css use...
	  MonthPrompt.addStyleName("promptStyle");
	  DayPrompt.addStyleName("promptStyle");
	  YearPrompt.addStyleName("promptStyle");
	  Output.addStyleName("outputStyle");
	  TheMonth.addStyleName("boxStyle");
	  TheDay.addStyleName("boxStyle");
	  TheYear.addStyleName("boxStyle");

	  // Listen for the Enter Key in each TextBox
          TheYear.addKeyDownHandler(new KeyDownHandler() {
	    public void onKeyDown(KeyDownEvent event) {
		  // First, did they hit enter? If not, ignore
		  if (event.getNativeKeyCode() == KeyCodes.KEY_ENTER) {
			  String TextToServer=new String(TheMonth.getText() + " " +
					    TheDay.getText() + " " + TheYear.getText());
			  // Clear the dialog boxes
			  TheMonth.setText("");
			  TheDay.setText("");
			  TheYear.setText("");
			  
			  // Send the data to the server
			  greetingService.greetServer(TextToServer, new AsyncCallback<String>() {
			    public void onFailure(Throwable caught) {
  			      // Show the RPC error message to the user
			      Output.setText("Server RPC Error");
			    }

			    public void onSuccess(String result) {
			      Output.setText("Days Elapsed:"+result);
			    }
			  });
	// Initialize theDate to refer to the correct object type
			  TheMonth.setFocus(true);
		  }
            }
          });
	  // Now, for the other two boxes. We use the same handler for them.
	  TheMonth.addKeyDownHandler(this);
	  TheDay.addKeyDownHandler(this);
	  
	  // Add the panels to the frame
	  // New way. Add to root panel.
	  RootPanel.get("Interface").add(Interface);
	  RootPanel.get("DaysElapsed").add(Result);
	  
	  // Put cursor in month box
	  TheMonth.setFocus(true);
  } // onModuleLoad

	// Handler for the KeyDownListener when this is listening
	public void onKeyDown(KeyDownEvent event) {
	  // First, did they hit enter? If not, ignore
	  if (event.getNativeKeyCode() == KeyCodes.KEY_ENTER) {
		if (event.getSource()==TheMonth)  // Move cursor to next box
		  TheDay.setFocus(true);
		else TheYear.setFocus(true);
	  }  
	}	
    
} // Class
